Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VariableBase.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VariableBase.cs	(revision 14828)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/VariableBase.cs	(revision 14829)
@@ -34,5 +34,5 @@
       get { return weightMu; }
       set {
-        if(value != weightMu) {
+        if (value != weightMu) {
           weightMu = value;
           OnChanged(EventArgs.Empty);
@@ -45,6 +45,6 @@
       get { return weightSigma; }
       set {
-        if(weightSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
-        if(value != weightSigma) {
+        if (weightSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
+        if (value != weightSigma) {
           weightSigma = value;
           OnChanged(EventArgs.Empty);
@@ -57,5 +57,5 @@
       get { return weightManipulatorMu; }
       set {
-        if(value != weightManipulatorMu) {
+        if (value != weightManipulatorMu) {
           weightManipulatorMu = value;
           OnChanged(EventArgs.Empty);
@@ -68,6 +68,6 @@
       get { return weightManipulatorSigma; }
       set {
-        if(weightManipulatorSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
-        if(value != weightManipulatorSigma) {
+        if (weightManipulatorSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
+        if (value != weightManipulatorSigma) {
           weightManipulatorSigma = value;
           OnChanged(EventArgs.Empty);
@@ -80,6 +80,6 @@
       get { return multiplicativeWeightManipulatorSigma; }
       set {
-        if(multiplicativeWeightManipulatorSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
-        if(value != multiplicativeWeightManipulatorSigma) {
+        if (multiplicativeWeightManipulatorSigma < 0.0) throw new ArgumentException("Negative sigma is not allowed.");
+        if (value != multiplicativeWeightManipulatorSigma) {
           multiplicativeWeightManipulatorSigma = value;
           OnChanged(EventArgs.Empty);
@@ -94,5 +94,5 @@
       get { return variableChangeProbability; }
       set {
-        if(value < 0 || value > 1.0) throw new ArgumentException("Variable change probability must lie in the interval [0..1]");
+        if (value < 0 || value > 1.0) throw new ArgumentException("Variable change probability must lie in the interval [0..1]");
         variableChangeProbability = value;
       }
@@ -104,5 +104,5 @@
       get { return variableNames; }
       set {
-        if(value == null) throw new ArgumentNullException();
+        if (value == null) throw new ArgumentNullException();
         variableNames.Clear();
         variableNames.AddRange(value);
@@ -116,5 +116,5 @@
       get { return allVariableNames; }
       set {
-        if(value == null) throw new ArgumentNullException();
+        if (value == null) throw new ArgumentNullException();
         allVariableNames.Clear();
         allVariableNames.AddRange(value);
@@ -124,9 +124,9 @@
     public override bool Enabled {
       get {
-        if(variableNames.Count == 0) return false;
+        if (variableNames.Count == 0) return false;
         return base.Enabled;
       }
       set {
-        if(variableNames.Count == 0) base.Enabled = false;
+        if (variableNames.Count == 0) base.Enabled = false;
         else base.Enabled = value;
       }
@@ -146,5 +146,5 @@
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserialization() {
-      if(allVariableNames == null || (allVariableNames.Count == 0 && variableNames.Count > 0)) {
+      if (allVariableNames == null || (allVariableNames.Count == 0 && variableNames.Count > 0)) {
         allVariableNames = variableNames;
       }
@@ -167,5 +167,5 @@
       multiplicativeWeightManipulatorSigma = original.multiplicativeWeightManipulatorSigma;
       variableChangeProbability = original.variableChangeProbability;
-      }
+    }
     protected VariableBase(string name, string description)
       : base(name, description) {