Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF1.cs	(revision 14853)
@@ -37,9 +37,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat",
         "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x20", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF2.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+      get { return new string[] { "Material_Cat",
+        "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "Material", "Grooving", "Oil",
         "x17", "x18", "x19", "x20", "x21", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
-        /*"Source1", "Source2",*/ "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+      get { return new string[] { "Material_Cat", 
+        "Source1",  "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "Material", "Grooving", "Oil",
         "x17", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat", 
         "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat",
         "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x18", "x19", "x21", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat",
         "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat",
         "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat",
         "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x18", "x19", "x20", "x21", "x22" }; }
     }
Index: trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 14791)
+++ trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 14853)
@@ -38,9 +38,8 @@
     }
 
-    // TODO: include string variables after factor branch integration
     protected override string[] AllowedInputVariables {
-      get { return new string[] { /* "Material_Cat", */
+      get { return new string[] { "Material_Cat", 
         "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
-        /* "Material", "Grooving", "Oil", */                                           
+        "Material", "Grooving", "Oil",
         "x17", "x18", "x19", "x20", "x21", "x22" }; }
     }